package com.logicbig.example;

import java.math.BigDecimal;
import java.math.RoundingMode;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;
import java.util.concurrent.ThreadLocalRandom;
import java.util.function.BiConsumer;

public enum TestDataService {
    Instance;
    private String[] currencyPairs = {"EUR/USD", "USD/JPY", "GBP/USD",
            "USD/CHF", "USD/CAD", "AUD/USD", "NZD/USD", "EUR/GBP",
            "EUR/AUD", "GBP/JPY", "CHF/JPY", "NZD/JPY", "GBP/CAD"};


    public void listenToDataUpdate(BiConsumer<String, BigDecimal> forexListener) {
        ExecutorService es = Executors.newSingleThreadExecutor();
        es.execute(new Runnable() {
            @Override
            public void run() {
                while (true) {
                    int i = ThreadLocalRandom.current().nextInt(0, currencyPairs.length);
                    BigDecimal rate = BigDecimal.valueOf(Math.random() * 10);
                    rate = rate.setScale(2, RoundingMode.CEILING);
                    forexListener.accept(currencyPairs[i], rate);
                    try {
                        Thread.sleep(10);
                    } catch (InterruptedException e) {
                        e.printStackTrace();
                    }
                }
            }
        });
    }
}