package com.logicbig.example;


import javax.swing.*;
import java.awt.*;
import java.math.BigDecimal;
import java.util.function.BiConsumer;

public class WithoutThrottlingExample {
    public static void main(String[] args) {
        ForexTableModel tableModel = new ForexTableModel();
        JTable table = new JTable(tableModel);
        listenToForexChanges(tableModel);
        JFrame frame = createFrame();
        frame.add(new JScrollPane(table));
        frame.setLocationRelativeTo(null);
        frame.setVisible(true);
    }

    private static void listenToForexChanges(ForexTableModel tableModel) {
        TestDataService.Instance.listenToDataUpdate((pair, rate) -> {
            tableModel.updateRateWithoutFiringEvent(pair, rate);
            tableModel.fireTableDataChanged();
        });
    }

    private static JFrame createFrame() {
        JFrame frame = new JFrame("Without Throttling Example");
        frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        frame.setSize(new Dimension(500, 300));
        return frame;
    }
}